
import geopandas as gpd
from glob import glob
import os
from fiona.crs import from_epsg

# diretorios de entrada e saida
path='G:\O18041\Sol39\B_Sig\Produtos\Shapes'
outputpath='G:\O18041\Sol39\B_Sig\Produtos\Shapes\sirgas'
# projecaoes de entrada e saida pelos valoes do epsg
EpsgIni=4326
EpsgOut=4674

if __name__=='__main__':
	# obter os nomes dos arquivos shapefile que estao no path
	fnames=os.path.join(path,'*.shp')
	# lista de atributos que podem ocorrer no shape det
	det = [
			'Shor_kg_m2',
			'MaxThck_mm',
			'OilThck_mm',
			'TotCon_ppb'
			'gm3'
		]	 
	
	# executar um loop nestes arquivos
	for fname in glob(fnames):
		
		# carregar o arquivo shape file
		gdf = gpd.read_file(fname)
	
		# detecatar o tipo de shape file
		# se prob:
		if '_prob_' in fname.lower():
			# colocar a coluna prob na selecao
			selection=['prob']
			# verificar se tem coluna, se nao tiver nao colocar mais nada, 
			# se tiver colocar tempo na selecao
			if 'coluna' not in fname.lower():
				selection= selection + ['tempo']
				# verificar se alem de nao ter coluna no nome ele, o shape e de costa
				# se for colocar massa na selecao
				if 'costa' in fname.lower():
					selection= selection + ['massa']
		# caso det
		else:
			# verificar qual a coluna que esta no shape det
			selection = [col for col in gdf.columns if col in det]
					
		# colocar nesta selecao a geometria do shape
		selection=selection+['geometry']
		# declarar a projecao do shape
		gdf.crs=from_epsg(EpsgIni)
		# conveter a projecao
		gdf = gdf.to_crs(epsg=EpsgOut)
		# pegar apenas o nome do arquivo
		_,outname = os.path.split(fname)
		# colocar o diretorio de interesse no nome do arquivo
		outname = os.path.join(outputpath,outname)
		# salvar o shape selecionando as info desejadas		
		gdf[selection].to_file(outname)	